package com.rp.util.sort;

import com.rp.util.sort.ISort;
import com.rp.util.sort.SortException;
import com.rp.util.ReflectionUtil;
import java.util.Comparator;
import java.util.List;

public final class SelectionSort implements ISort
{
	public SelectionSort ()
	{}
	
	public void sort (int[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}
	
	public void sort (int[] arr, int begin, int end)
	{
 		int min;
 		int temp;

		for (int i = begin; i <= end; i++)
		{
			min = i;
			for (int j = i+1; j <= end; j++)
			{
				if (arr[j] < arr[min])
					min = j;
			}
			temp = arr[i];
			arr[i] = arr[min];
			arr[min] = temp;
		}
	}
	
	public void sort (String[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}
	
	public void sort (String[] arr, int begin, int end)
	{
 		int min;
 		String temp;

		for (int i = begin; i <= end; i++)
		{
			min = i;
			for (int j = i+1; j <= end; j++)
			{
				if (arr[j].compareToIgnoreCase(arr[min]) < 0)
					min = j;
			}
			temp = arr[i];
			arr[i] = arr[min];
			arr[min] = temp;
		}
	}
	
	public void sort (long[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}
	
	public void sort (long[] arr, int begin, int end)
	{
 		int min;
 		long temp;

		for (int i = begin; i <= end; i++)
		{
			min = i;
			for (int j = i+1; j <= end; j++)
			{
				if (arr[j] < arr[min])
					min = j;
			}
			temp = arr[i];
			arr[i] = arr[min];
			arr[min] = temp;
		}
	}
	
	public void sort (short[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}
	
	public void sort (short[] arr, int begin, int end)
	{
 		int min;
 		short temp;

		for (int i = begin; i <= end; i++)
		{
			min = i;
			for (int j = i+1; j <= end; j++)
			{
				if (arr[j] < arr[min])
					min = j;
			}
			temp = arr[i];
			arr[i] = arr[min];
			arr[min] = temp;
		}
	}
	
	public void sort (double[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}
	
	public void sort (double[] arr, int begin, int end)
	{
 		int min;
 		double temp;

		for (int i = begin; i <= end; i++)
		{
			min = i;
			for (int j = i+1; j <= end; j++)
			{
				if (arr[j] < arr[min])
					min = j;
			}
			temp = arr[i];
			arr[i] = arr[min];
			arr[min] = temp;
		}
	}
	
	public void sort (float[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}
	
	public void sort (float[] arr, int begin, int end)
	{
 		int min;
 		float temp;

		for (int i = begin; i <= end; i++)
		{
			min = i;
			for (int j = i+1; j <= end; j++)
			{
				if (arr[j] < arr[min])
					min = j;
			}
			temp = arr[i];
			arr[i] = arr[min];
			arr[min] = temp;
		}
	}
	
	public void sort (char[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}
	
	public void sort (char[] arr, int begin, int end)
	{
 		int min;
 		char temp;

		for (int i = begin; i <= end; i++)
		{
			min = i;
			for (int j = i+1; j <= end; j++)
			{
				if (arr[j] < arr[min])
					min = j;
			}
			temp = arr[i];
			arr[i] = arr[min];
			arr[min] = temp;
		}
	}
	
	public void sort (byte[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}
	
	public void sort (byte[] arr, int begin, int end)
	{
 		int min;
 		byte temp;

		for (int i = begin; i <= end; i++)
		{
			min = i;
			for (int j = i+1; j <= end; j++)
			{
				if (arr[j] < arr[min])
					min = j;
			}
			temp = arr[i];
			arr[i] = arr[min];
			arr[min] = temp;
		}
	}
	
	public void sort (Object[] arr, Comparator c, String methodName) throws SortException
	{
		sort (arr, c, methodName, new Class[0], new Object[0]);	
	}
	
	public void sort (Object[] arr, Comparator c, String methodName, Class[] paramTypes, Object[] paramValues)  
							throws SortException
	{
		sort (arr, 0, arr.length-1, c, methodName, paramTypes, paramValues);	
	}
	
	public void sort (Object[] arr, int begin, int end, Comparator c, String methodName)  
							throws SortException
	{
		sort (arr, begin, end, c, methodName, new Class[0], new Object[0]);
	}
	
	public void sort (Object[] arr, int begin, int end, Comparator c, String methodName, 
							Class[] paramTypes, Object[] paramValues)  
							throws SortException
	{
		try
		{
			int min;
	 		Object temp;
	
			for (int i = begin; i <= end; i++)
			{
				min = i;
				for (int j = i+1; j <= end; j++)
				{
					if (c.compare(ReflectionUtil.getMethodValue (arr[j], methodName, paramTypes, paramValues), 
						ReflectionUtil.getMethodValue (arr[min], methodName, paramTypes, paramValues)) < 0)
					{
						min = j;
					}
				}
				temp = arr[i];
				arr[i] = arr[min];
				arr[min] = temp;
			}
		}
		catch (Exception e)
		{
			throw new SortException (e);	
		}
	}
	
	public void sort (Object[] arr, Comparator c)
	{
		sort (arr, 0, arr.length-1, c);	
	}
	
	public void sort (Object[] arr, int begin, int end, Comparator c)
	{
		int min;
		Object temp;

		for (int i = begin; i <= end; i++)
		{
			min = i;
			for (int j = i+1; j <= end; j++)
			{
				if (c.compare(arr[j], arr[min]) < 0)
					min = j;
			}
			temp = arr[i];
			arr[i] = arr[min];
			arr[min] = temp;
		}
	}
	
	public void sort (List arr, Comparator c)
	{
		sort (arr, 0, arr.size()-1, c);	
	}
	
	public void sort (List arr, int begin, int end, Comparator c)
	{
		int min;
		Object temp;

		for (int i = begin; i <= end; i++)
		{
			min = i;
			for (int j = i+1; j <= end; j++)
			{
				if (c.compare(arr.get(j), arr.get(min)) < 0)
					min = j;
			}
			temp = arr.get(i);
			arr.set(i, arr.get(min));
			arr.set(min, temp);
		}
	}
}